=== modified file 'src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java'
--- src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2021-06-10 11:50:04 +0000
+++ src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2021-06-18 18:47:18 +0000
@@ -194,6 +194,8 @@
 import com.goldencode.p2j.ui.client.gui.*;
 import com.goldencode.p2j.ui.client.gui.SliderGuiImpl.*;
 import com.goldencode.p2j.ui.client.gui.TabSetGuiImpl.*;
+import com.goldencode.p2j.ui.client.gui.TreeGuiImpl.TreeNode;
+import com.goldencode.p2j.ui.client.gui.TreeListGuiImpl.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
 import com.goldencode.p2j.ui.client.gui.driver.LightweightTextWidget.*;
 import com.goldencode.p2j.ui.client.gui.theme.Theme.TextLookAndFeel.*;
@@ -215,7 +217,7 @@
    public static final int TREEVIEW_INNER_PADDING = 2;
 
    /** Treeview expand icon horizontal offset */
-   public static final int TREEVIEW_EXPAND_ICON_OFFSET = 7;
+   public static final int TREEVIEW_EXPAND_ICON_OFFSET = 1;
 
    /** Treeview expand icon size */
    public static final int TREEVIEW_EXPAND_ICON_SIZE = 9;
@@ -344,7 +346,7 @@
    protected static final int ROW_TOGGLE_SIZE = 13;
 
    /** Treeview node level offset */
-   private static final int TREEVIEW_NODE_LEVEL_OFFSET = 26;
+   private static final int TREEVIEW_NODE_LEVEL_OFFSET = 16;
 
    /** Color of the treeview expand icon */
    private static final ColorRgb TREEVIEW_EXPAND_ICON_COLOR = new ColorRgb(0x000000);
@@ -2245,6 +2247,7 @@
     * @param  chkMarkColor
     *         ColorRgb - RGB color for checkmark.
     */
+   @SuppressWarnings("static-method")
    private void drawCheckmark(GuiDriver gd, NativePoint p, ColorRgb chkMarkColor)
    {
       gd.setColor(chkMarkColor);
@@ -2459,41 +2462,43 @@
     *          If the mouse is hovering over the button.
     */
    @Override
-   public void drawScrollBarButton(GuiDriver gd,
-                                   GuiColorResolver gc,
-                                   int x,
-                                   int y,
-                                   int width,
-                                   int height,
-                                   ScrollBar.Position pos,
-                                   boolean horizontal,
-                                   boolean enabled,
-                                   boolean pressed,
-                                   boolean highlighted)
+   public void drawScrollBarButton(final GuiDriver gd,
+                                   final GuiColorResolver gc,
+                                   final int x,
+                                   final int y,
+                                   final int width,
+                                   final int height,
+                                   final ScrollBar.Position pos,
+                                   final boolean horizontal,
+                                   final boolean enabled,
+                                   final boolean pressed,
+                                   final boolean highlighted)
    {
+      int xi = x;
+      int yi = y;
       gd.setColor(gc.bgColor);
-      gd.fillRect(x, y, width, height);
+      gd.fillRect(xi, yi, width, height);
       
       // 3D border
       if (!pressed)
       {
          // top-left part
          gd.setColor(gd.getSysColor(SysColor.COLOR_WINDOW));
-         gd.drawLine(x + 1, y + 1, x + 1,         y + height - 3);
-         gd.drawLine(x + 2, y + 1, x + width - 3, y + 1);
+         gd.drawLine(xi + 1, yi + 1, xi + 1,         yi + height - 3);
+         gd.drawLine(xi + 2, yi + 1, xi + width - 3, yi + 1);
          // bottom-right part
          gd.setColor(gd.getSysColor(SysColor.COLOR_3DDKSHADOW));
-         gd.drawLine(x,             y + height - 1, x + width - 1, y + height - 1);
-         gd.drawLine(x + width - 1, y,              x + width - 1, y + height - 2);
+         gd.drawLine(xi,             yi + height - 1, xi + width - 1, yi + height - 1);
+         gd.drawLine(xi + width - 1, yi,              xi + width - 1, yi + height - 2);
          // shadow corner
          gd.setColor(gd.getSysColor(SysColor.COLOR_3DSHADOW));
-         gd.drawLine(x + 1,         y + height - 2, x + width - 2, y + height - 2);
-         gd.drawLine(x + width - 2, y + 1,          x + width - 2, y + height - 3);
+         gd.drawLine(xi + 1,         yi + height - 2, xi + width - 2, yi + height - 2);
+         gd.drawLine(xi + width - 2, yi + 1,          xi + width - 2, yi + height - 3);
       }
       else
       {
          gd.setColor(gd.getSysColor(SysColor.COLOR_3DSHADOW));
-         gd.drawRect(x, y, width - 1, height - 1);
+         gd.drawRect(xi, yi, width - 1, height - 1);
       }
    
       // draw arrow images loaded before
@@ -2529,13 +2534,13 @@
          // calc size and centered location
          w = img.getWidth();
          h = img.getHeight();
-         x += (width - w) / 2;
-         y += (height - h) / 2;
+         xi += (width - w) / 2;
+         yi += (height - h) / 2;
       
          // for enabled buttons need to consider Up/Down state difference
          gd.drawImage(img,
-               !pressed || !enabled ? x : x + 1,
-               !pressed || !enabled ? y : y + 1,
+               !pressed || !enabled ? xi : xi + 1,
+               !pressed || !enabled ? yi : yi + 1,
                w, h, 0, 0, false, false, false, false);
       }
    }
@@ -2657,6 +2662,7 @@
     * @param   y2
     *          The bottom extremity of the caret.
     */
+   @SuppressWarnings("static-method")
    protected void drawCaret(GuiDriver gd, int x1, int y1, int x2, int y2)
    {
       // the caret color to be XOR-ed with current content
@@ -3872,6 +3878,7 @@
     * @param   gd
     *          the active {@code GuiDriver} used to draw the browse widget.
     */
+   @SuppressWarnings("static-method")
    protected void setCompositeXorColor(GuiDriver gd)
    {
       gd.setColor(BROWSE_ROW_XOR_COLOR);
@@ -4049,8 +4056,8 @@
                                     GuiDriver gd,
                                     GuiColorResolver gc,
                                     GuiFontResolver gf,
-                                    int x,
-                                    int y,
+                                    final int x,
+                                    final int y,
                                     int width,
                                     int height)
    {
@@ -4065,14 +4072,13 @@
       // calculate text position
       FontDetails font = gf.font().font;
       int textWidth = browse.getTextWidth(title, font);
-      x += (width - textWidth) / 2;
       
       // draw title string
       gd.setColor(focused ? gc.titleFgColor : titleInactiveFgColor);
       gd.setGuiFont(font);
       gd.drawStringCentered(title, 
-                            x, 
-                            browse.getTitleHeight() / 2 + BrowseGuiImpl.BORDER_THICKNESS);
+               x + (width - textWidth) / 2, 
+               browse.getTitleHeight() / 2 + BrowseGuiImpl.BORDER_THICKNESS);
    }
    
    /**
@@ -4372,6 +4378,7 @@
     *
     * @return row marker image for a row.
     */
+   @SuppressWarnings("static-method")
    protected ImageWrapper getBrowseMarkerArrow(boolean selected)
    {
       final int ROW_MARKER_IMAGE_SIZE = 16;
@@ -4418,6 +4425,7 @@
     *
     * @return the image of a non-edited in-browse toggle-box.
     */
+   @SuppressWarnings("static-method")
    protected ImageWrapper getRowToggleImage(boolean checked)
    {
       return VectorGraphicsHelper.getScalableImage(checked ? "row-toggle-on" : "row-toggle-off",
@@ -4434,6 +4442,7 @@
     *          The color for unselected cells. If {@code null} then the unselected cells' 
     *          background is not drawn. 
     */
+   @SuppressWarnings("static-method")
    protected void setBrowseCellBackgroundSelectionColor(GuiDriver gd, ColorRgb unselColor)
    {
       gd.setColor(ColorManager.getSysColor(SysColor.COLOR_ACTIVECAPTION));
@@ -4874,6 +4883,7 @@
     *
     * @return clip point for the sort arrow inside the column header.
     */
+   @SuppressWarnings("static-method")
    protected NativePoint getSortArrowClipPoint(BrowseColumnGuiImpl column,
                                                NativePoint textClipPoint,
                                                NativeRectangle textClipRectangle)
@@ -4916,6 +4926,7 @@
     * @param   y
     *          Starting Y coord of the text.
     */
+   @SuppressWarnings("static-method")
    protected void drawBrowseCellLabel(BrowseColumnGuiImpl column,
                                       GuiDriver gd,
                                       String text,
@@ -5032,12 +5043,11 @@
 
       // calculate text position
       int textWidth = frame.getTextWidthNative(title, gf.resolveFontNum());
-      x += (width - textWidth) / 2 - 1;
       
       // draw title string
       gd.setColor(gc.titleFgColor);
       gd.setGuiFont(gf.font().font);
-      gd.drawStringCentered(title, x, height / 2);
+      gd.drawStringCentered(title, x + (width - textWidth) / 2 - 1, height / 2);
    }
 
    /**
@@ -5343,8 +5353,8 @@
                                  GuiDriver gd,
                                  GuiFontResolver gf,
                                  GuiColorResolver gc,
-                                 int x,
-                                 int y,
+                                 final int x,
+                                 final int y,
                                  int width,
                                  int height,
                                  NativePoint selStart,
@@ -5352,6 +5362,7 @@
                                  int dx,
                                  int dy)
    {
+      int yi = y;
       gd.setGuiFont(gf.font().font);
       
       int fontDescent = 2; // TODO: use font.descent instead of constant 2
@@ -5374,7 +5385,7 @@
             gd.drawTextSelection(textLine,
                                  textLookAndFeel,
                                  x - dx,
-                                 y,
+                                 yi,
                                  fontHeight,
                                  fontDescent);
          }
@@ -5385,10 +5396,10 @@
             gd.setColor(textLookAndFeel.getTextColor());
             
             // adjust for scrollX
-            gd.drawString(txt, x - dx, y + fontHeight - fontDescent);
+            gd.drawString(txt, x - dx, yi + fontHeight - fontDescent);
          }
          
-         y += fontHeight;
+         yi += fontHeight;
       }
    }
    
@@ -5636,6 +5647,7 @@
     * @return <code>true</code> if the upper part of the column's right separator should NOT be
     *         drawn because of the quirk described above.
     */
+   @SuppressWarnings("static-method")
    protected boolean isBrowseLabelBorderDrawQuirk(BrowseColumnGuiImpl column)
    {
       return column.isLastLockedColumn() &&
@@ -6115,10 +6127,12 @@
    public void drawSliderTicMarks(SliderGuiImpl slider,
                                    GuiDriver gd,
                                    GuiColorResolver gc,
-                                   int x,
-                                   int y,
+                                   final int x,
+                                   final int y,
                                    int length)
    {
+      int xi = x;
+      int yi = y;
       // get slider config
       SliderConfig config = slider.config();
       TicMarks tmMode = slider.getTicmarkMode();
@@ -6140,10 +6154,10 @@
          // tics above ruler 
          if (tmMode == TicMarks.TOP || tmMode == TicMarks.BOTH)
          {
-            y += tmMode == TicMarks.TOP ? 1 : 0;
+            yi += tmMode == TicMarks.TOP ? 1 : 0;
             // extra length marks on edges
-            gd.drawLine(x, y - shift, x, y - shift - TM_LENGTH - 1);
-            gd.drawLine(x + length, y - shift, x + length, y - shift - TM_LENGTH - 1);
+            gd.drawLine(xi, yi - shift, xi, yi - shift - TM_LENGTH - 1);
+            gd.drawLine(xi + length, yi - shift, xi + length, yi - shift - TM_LENGTH - 1);
             
             // regular tics between edges, when frequency == 0 there must be no tics between edges
             if (config.frequency > 0)
@@ -6151,8 +6165,8 @@
                for (int i = config.minValue + config.frequency;
                     i < config.maxValue; i += config.frequency)
                {
-                  int xt = slider.indexToCoord(x, length, true, i);
-                  gd.drawLine(xt, y - shift, xt, y - shift - TM_LENGTH);
+                  int xt = slider.indexToCoord(xi, length, true, i);
+                  gd.drawLine(xt, yi - shift, xt, yi - shift - TM_LENGTH);
                }
             }
             // BOTH mode need to change the shift
@@ -6164,11 +6178,11 @@
          // tics below ruler
          if (tmMode == TicMarks.BOTTOM || tmMode == TicMarks.BOTH)
          {
-            y -= tmMode == TicMarks.BOTTOM ? 1 : 0;
+            yi -= tmMode == TicMarks.BOTTOM ? 1 : 0;
             
             // extra length marks on edges
-            gd.drawLine(x, y + shift, x, y + shift + TM_LENGTH + 1);
-            gd.drawLine(x + length, y + shift, x + length, y + shift + TM_LENGTH + 1);
+            gd.drawLine(xi, yi + shift, xi, yi + shift + TM_LENGTH + 1);
+            gd.drawLine(xi + length, yi + shift, xi + length, yi + shift + TM_LENGTH + 1);
             
             // regular tics between edges, when frequency == 0 there must be no tics between edges
             if (config.frequency > 0)
@@ -6176,8 +6190,8 @@
                for (int i = config.minValue + config.frequency;
                     i < config.maxValue; i += config.frequency)
                {
-                  int xt = slider.indexToCoord(x, length, true, i);
-                  gd.drawLine(xt, y + shift, xt, y + shift + TM_LENGTH);
+                  int xt = slider.indexToCoord(xi, length, true, i);
+                  gd.drawLine(xt, yi + shift, xt, yi + shift + TM_LENGTH);
                }
             }
          }
@@ -6187,11 +6201,11 @@
          // tics left to the ruler
          if (tmMode == TicMarks.LEFT || tmMode == TicMarks.BOTH)
          {
-            x += tmMode == TicMarks.LEFT ? 1 : 0;
+            xi += tmMode == TicMarks.LEFT ? 1 : 0;
             
             // extra length marks on edges
-            gd.drawLine(x - shift, y, x - shift - TM_LENGTH - 1, y);
-            gd.drawLine(x - shift, y + length, x - shift - TM_LENGTH - 1, y + length);
+            gd.drawLine(xi - shift, yi, xi - shift - TM_LENGTH - 1, yi);
+            gd.drawLine(xi - shift, yi + length, xi - shift - TM_LENGTH - 1, yi + length);
             
             // regular tics between edges, when frequency == 0 there must be no tics between edges
             if (config.frequency > 0)
@@ -6199,8 +6213,8 @@
                for (int i = config.minValue + config.frequency;
                     i < config.maxValue; i += config.frequency)
                {
-                  int yt = slider.indexToCoord(y, length, true, i);
-                  gd.drawLine(x - shift, yt, x - shift - TM_LENGTH, yt);
+                  int yt = slider.indexToCoord(yi, length, true, i);
+                  gd.drawLine(xi - shift, yt, xi - shift - TM_LENGTH, yt);
                }
             }
             // BOTH mode need to change the shift
@@ -6213,11 +6227,11 @@
          // tics right ruler
          if (tmMode == TicMarks.RIGHT || tmMode == TicMarks.BOTH)
          {
-            x -= tmMode == TicMarks.RIGHT ? 1 : 0;
+            xi -= tmMode == TicMarks.RIGHT ? 1 : 0;
             
             // extra length marks on edges
-            gd.drawLine(x + shift, y, x + shift + TM_LENGTH + 1, y);
-            gd.drawLine(x + shift, y + length, x + shift + TM_LENGTH + 1, y + length);
+            gd.drawLine(xi + shift, yi, xi + shift + TM_LENGTH + 1, yi);
+            gd.drawLine(xi + shift, yi + length, xi + shift + TM_LENGTH + 1, yi + length);
             
             // regular tics between edges, when frequency == 0 there must be no tics between edges
             if (config.frequency > 0)
@@ -6225,8 +6239,8 @@
                for (int i = config.minValue + config.frequency;
                     i < config.maxValue; i += config.frequency)
                {
-                  int yt = slider.indexToCoord(y, length, true, i);
-                  gd.drawLine(x + shift, yt, x + shift + TM_LENGTH, yt);
+                  int yt = slider.indexToCoord(yi, length, true, i);
+                  gd.drawLine(xi + shift, yt, xi + shift + TM_LENGTH, yt);
                }
             }
          }
@@ -6241,6 +6255,7 @@
     *
     * @return  the color used for drawing the tic-marks. 
     */
+   @SuppressWarnings("static-method")
    protected ColorRgb getSliderTicmarkColor(GuiColorResolver gc)
    {
       return gc.fgColor;
@@ -6442,7 +6457,7 @@
     * @return   The tree node label's horizontal offset
     */
    @Override
-   public int getTreeViewNodeContentHorizontalOffset(int level)
+   public int getTreeViewNodeContentHorizontalOffset(final int level)
    {
       return TREEVIEW_INNER_PADDING + getTreeViewNodeHorizontalOffset(level);
    }
@@ -6556,6 +6571,27 @@
    }
 
    /**
+    * Draw a dotted vertical line with current color.
+    * 
+    * @param gd
+    *        the gui driver
+    * @param x
+    *        the x coordinate of both line ends
+    * @param top
+    *        the y coordinate of the line start
+    * @param bottom
+    *        the y coordinate of the line end, must be greater or equal the top argument
+    */
+   private static void drawDottedVerticalLine(final GuiDriver gd, final int x, final int top,
+            final int bottom)
+   {
+      for (int y = top; y < bottom; y += 2)
+      {
+         gd.drawLine(x, y, x, y);
+      }
+   }
+   
+   /**
     * Draws treeview body.
     *
     * @param   gd
@@ -6566,14 +6602,16 @@
     *          Text font.
     * @param   tree
     *          Tree widget, the owner of the tree body.
-    * @param   nodes
-    *          Nodes to draw.
+    * @param   topNode
+    *          the first node to draw, may by {@code null} for an empty tree.
     * @param   currentNode
     *          Current node.
     * @param   valueIndex
     *          The index of the value to be displayed. For TREEVIEW widget this is always 0.
     * @param   width
-    *          Treeview body dimension.
+    *          Treeview body width.
+    * @param   height
+    *          Treeview body height.
     * @param   selectionBack
     *          Selection back color.
     * @param   selectionFore
